diff -ur snort-2.0.2/src/decode.h snort-2.0.2-ipv6/src/decode.h
--- snort-2.0.2/src/decode.h	Wed Jul 23 03:24:50 2003
+++ snort-2.0.2-ipv6/src/decode.h	Thu Dec  4 15:33:14 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: decode.h,v 1.73 2003/07/22 18:24:50 chrisgreen Exp $ */
+/* $Id: decode.h,v 1.6 2003/11/29 06:38:58 abekatsu Exp $ */
 
 
 #ifndef __DECODE_H__
@@ -169,9 +169,11 @@
 
 /* otherwise defined in /usr/include/ppp_defs.h */
 #define IP_HEADER_LEN           20
+#define IP6_HEADER_LEN          40
 #define TCP_HEADER_LEN          20
 #define UDP_HEADER_LEN          8
 #define ICMP_HEADER_LEN         4
+#define ICMP6_HEADER_LEN        4
 
 #define TCP_OPTLENMAX           40 /* (((2^4) - 1) * 4  - TCP_HEADER_LEN) */
 
@@ -179,6 +181,8 @@
 #define	IP_MAXPACKET	65535		/* maximum packet size */
 #endif /* IP_MAXPACKET */
 
+#define MAX_IPv6_OPT 40 /* why it definds 40 */
+
 #define TH_FIN  0x01
 #define TH_SYN  0x02
 #define TH_RST  0x04
@@ -423,6 +427,69 @@
 #define ICMP_PARAM_OPTMISSING   1
 #define ICMP_PARAM_BAD_LENGTH   2
 
+#define ICMP6_DST_UNREACH		1	/* dest unreachable, codes: */
+#define ICMP6_PACKET_TOO_BIG		2	/* packet too big */
+#define ICMP6_TIME_EXCEEDED		3	/* time exceeded, code: */
+#define ICMP6_PARAM_PROB		4	/* ip6 header bad */
+
+#define ICMP6_ECHO_REQUEST		128	/* echo service */
+#define ICMP6_ECHO_REPLY		129	/* echo reply */
+#define ICMP6_MEMBERSHIP_QUERY		130	/* group membership query */
+#define MLD_LISTENER_QUERY		130 	/* multicast listener query */
+#define ICMP6_MEMBERSHIP_REPORT		131	/* group membership report */
+#define MLD_LISTENER_REPORT		131	/* multicast listener report */
+#define ICMP6_MEMBERSHIP_REDUCTION	132	/* group membership termination */
+#define MLD_LISTENER_DONE		132	/* multicast listener done */
+#define ND_ROUTER_SOLICIT		133	/* router solicitation */
+#define ND_ROUTER_ADVERT		134	/* router advertisment */
+#define ND_NEIGHBOR_SOLICIT		135	/* neighbor solicitation */
+#define ND_NEIGHBOR_ADVERT		136	/* neighbor advertisment */
+#define ND_REDIRECT			137	/* redirect */
+
+#define ICMP6_ROUTER_RENUMBERING	138	/* router renumbering */
+
+#define ICMP6_WRUREQUEST		139	/* who are you request */
+#define ICMP6_WRUREPLY			140	/* who are you reply */
+#define ICMP6_FQDN_QUERY		139	/* FQDN query */
+#define ICMP6_FQDN_REPLY		140	/* FQDN reply */
+#define ICMP6_NI_QUERY			139	/* node information request */
+#define ICMP6_NI_REPLY			140	/* node information reply */
+
+#define ICMP6_PREFIX_REQUEST            150     /*XXX local agreement*/
+#define ICMP6_PR_DELEGATOR_QUERY        0
+#define ICMP6_PR_INITIAL_REQUEST        1
+#define ICMP6_PR_RENEWAL_REQUEST        2
+#define ICMP6_PR_PREFIX_RETURN          3
+
+#define ICMP6_PREFIX_DELEGATION         151     /*XXX local agreement*/
+#define ICMP6_PD_PREFIX_DELEGATOR       0
+#define ICMP6_PD_AUTH_REQUIRED          1
+#define ICMP6_PD_AUTH_FAILED            2
+#define ICMP6_PD_PREFIX_UNAVAIL         3
+#define ICMP6_PD_PREFIX_DELEGATED       4
+#define ICMP6_PD_PREFIX_RETURNED        5
+
+#define ICMP6_MOBILEPREFIX_SOLICIT      152     /* XXX To be authorized */
+#define ICMP6_MOBILEPREFIX_ADVERT       153     /* XXX To be authorized */
+
+
+/* Codes for ICMP6 UNREACHABLES */
+#define ICMP6_DST_UNREACH_NOROUTE	0	/* no route to destination */
+#define ICMP6_DST_UNREACH_ADMIN	 	1	/* administratively prohibited */
+#define ICMP6_DST_UNREACH_NOTNEIGHBOR	2	/* not a neighbor(obsolete) */
+#define ICMP6_DST_UNREACH_BEYONDSCOPE	2	/* beyond scope of source address */
+#define ICMP6_DST_UNREACH_ADDR		3	/* address unreachable */
+#define ICMP6_DST_UNREACH_NOPORT	4	/* port unreachable */
+
+/* Codes for ICMP6 TIME EXCEED */
+#define ICMP6_TIME_EXCEED_TRANSIT 	0	/* ttl==0 in transit */
+#define ICMP6_TIME_EXCEED_REASSEMBLY	1	/* ttl==0 in reass */
+
+/* Codes for ICMP6 PARAMPROB */
+#define ICMP6_PARAMPROB_HEADER 	 	0	/* erroneous header field */
+#define ICMP6_PARAMPROB_NEXTHEADER	1	/* unrecognized next header */
+#define ICMP6_PARAMPROB_OPTION		2	/* unrecognized option */
+
 /* ip option type codes */
 #ifndef IPOPT_EOL
     #define IPOPT_EOL            0x00
@@ -805,6 +872,36 @@
     struct in_addr ip_src;  /* source IP */
     struct in_addr ip_dst;  /* dest IP */
 }      IPHdr;
+
+typedef struct _IP6Hdr
+{
+    union {
+	struct s_ip6_hdrctl {
+	    u_int32_t ip6_un1_flow;	/* 20 bits of flow-ID */
+	    u_int16_t ip6_un1_plen;	/* payload length */
+	    u_int8_t  ip6_un1_nxt;	/* next header */
+	    u_int8_t  ip6_un1_hlim;	/* hop limit */
+	} ip6_un1;
+	u_int8_t ip6_un2_vfc;	/* 4 bits version, top 4 bits class */
+    } ip6_ctlun;
+    struct in6_addr ip6_src;	/* source address */
+    struct in6_addr ip6_dst;	/* destination address */    
+}     IP6Hdr;
+#define s_ip6_vfc	ip6_ctlun.ip6_un2_vfc
+#define s_ip6_flow	ip6_ctlun.ip6_un1.ip6_un1_flow
+#define s_ip6_plen	ip6_ctlun.ip6_un1.ip6_un1_plen
+#define s_ip6_nxt	ip6_ctlun.ip6_un1.ip6_un1_nxt
+#define s_ip6_hlim	ip6_ctlun.ip6_un1.ip6_un1_hlim
+#define s_ip6_hops	ip6_ctlun.ip6_un1.ip6_un1_hlim
+
+typedef struct _IP6Frag
+{
+     u_int8_t	ip6frag_nxt;	/* next header */
+     u_int8_t	ip6frag_rsv;	/* reserved */
+     u_int16_t	ip6frag_off;	/* fragment offset and M frag */
+     u_int32_t	ip6frag_ide;	/* identification field */
+}     IP6Frag;
+
 #ifdef WIN32
   /* Visual C++ pragma to enable warning messages about nonstandard bit field type */
   #pragma warning( default : 4214 )
@@ -942,6 +1039,25 @@
 
 }        ICMPHdr;
 
+typedef struct _ICMP6Hdr 
+{
+    u_int8_t	icmp6_type;	/* type field */
+    u_int8_t	icmp6_code;	/* code field */
+    u_int16_t	icmp6_cksum;	/* checksum field */
+    union {
+	u_int32_t	icmp6_un_data32[1]; /* type-specific field */
+	u_int16_t	icmp6_un_data16[2]; /* type-specific field */
+	u_int8_t	icmp6_un_data8[4];  /* type-specific field */
+    } icmp6_dataun;
+}        ICMP6Hdr;
+#define s_icmp6_data32	icmp6_dataun.icmp6_un_data32
+#define s_icmp6_data16	icmp6_dataun.icmp6_un_data16
+#define s_icmp6_data8	icmp6_dataun.icmp6_un_data8
+#define s_icmp6_pptr	s_icmp6_data32[0]	/* parameter prob */
+#define s_icmp6_mtu	s_icmp6_data32[0]	/* packet too big */
+#define s_icmp6_id	s_icmp6_data16[0]	/* echo request/reply */
+#define s_icmp6_seq	s_icmp6_data16[1]	/* echo request/reply */
+#define s_icmp6_maxdelay	s_icmp6_data16[0]		/* mcast group membership */
 
 typedef struct _echoext
 {
@@ -1001,6 +1117,15 @@
     u_int8_t *data;
 }        Options;
 
+typedef struct _IPv6Opt
+{
+    u_int8_t type;
+    u_int8_t next;
+    u_int32_t len;
+    u_int8_t *data;
+}        IPv6Opt;
+
+
 /* PPPoEHdr Header; EtherHdr plus the PPPoE Header */
 typedef struct _PPPoEHdr
 {
@@ -1140,12 +1265,17 @@
     u_int32_t ip_options_len;
     u_int8_t *ip_options_data;
 
+    IP6Hdr *ip6h, *orig_ip6h;
+
+    IP6Frag *ip6fh;
+
     TCPHdr *tcph, *orig_tcph;
     u_int32_t tcp_options_len;
     u_int8_t *tcp_options_data;
 
     UDPHdr *udph, *orig_udph;
     ICMPHdr *icmph, *orig_icmph;
+    ICMP6Hdr *icmp6h, *orig_icmp6h;
 
     echoext *ext;       /* ICMP echo extension struct */
 
@@ -1179,7 +1309,10 @@
     u_int32_t tcp_option_count;
     u_char tcp_lastopt_bad;  /* flag to indicate that option decoding was
                                 halted due to a bad option */
-
+    IPv6Opt ip6_options[MAX_IPv6_OPT]; /* IPv6 Option Header decode structure */
+    u_int32_t ip6_option_count;  /* number of Option Header in this packet */
+    u_char ip6_lastopt_bad;  /* flag to indicate that option decoding was
+				halted due to a bad option */
     u_int8_t csum_flags;        /* checksum flags */
     u_int32_t packet_flags;     /* special flags for the packet */
     int preprocessors;          /* flags for preprocessors to check */
@@ -1221,7 +1354,7 @@
 void DecodeARP(u_int8_t *, u_int32_t, Packet *);
 void DecodeEapol(u_int8_t *, u_int32_t, Packet *);
 void DecodeEapolKey(u_int8_t *, u_int32_t, Packet *);
-void DecodeIPV6(u_int8_t *, u_int32_t);
+void DecodeIPV6(u_int8_t *, u_int32_t, Packet *);
 void DecodeIPX(u_int8_t *, u_int32_t);
 void DecodeTCP(u_int8_t *, const u_int32_t, Packet *);
 void DecodeUDP(u_int8_t *, const u_int32_t, Packet *);
@@ -1231,6 +1364,9 @@
 void DecodeTCPOptions(u_int8_t *, u_int32_t, Packet *);
 void DecodeIPOptions(u_int8_t *, u_int32_t, Packet *);
 void DecodePPPoEPkt(Packet *, struct pcap_pkthdr *, u_int8_t *);
+void DecodeIP6Frag(u_int8_t *, const u_int32_t, Packet *);
+void DecodeIP6Opt(u_int8_t *, const u_int32_t, Packet *);
+void DecodeICMPV6(u_int8_t *, const u_int32_t, Packet *);
 #if defined(WORDS_MUSTALIGN) && !defined(__GNUC__)
 u_int32_t EXTRACT_32BITS (u_char *);
 #endif /* WORDS_MUSTALIGN && !__GNUC__ */
diff -ur snort-2.0.2/src/detect.c snort-2.0.2-ipv6/src/detect.c
--- snort-2.0.2/src/detect.c	Tue Aug  5 00:18:35 2003
+++ snort-2.0.2-ipv6/src/detect.c	Sat Nov 29 15:44:44 2003
@@ -1,4 +1,4 @@
-/* $Id: detect.c,v 1.38 2003/08/04 15:18:35 chrisgreen Exp $ */
+/* $Id: detect.c,v 1.5 2003/11/29 06:44:44 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 2002, Sourcefire, Inc.
@@ -34,6 +34,9 @@
 #include <string.h>
 #include <stdlib.h>
 #include <assert.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netdb.h>
 
 #include "snort.h"
 #include "detect.h"
@@ -304,7 +307,7 @@
 
     check_tags_flag = 1;
 
-    if(p && p->iph == NULL)
+    if(p && p->iph == NULL && p->ip6h == NULL)
         return 0;
 
     /*
@@ -355,6 +358,182 @@
 
 }
 
+#if HAVE_GETNAMEINFO 
+int CheckAddrPort(IpAddrSet *rule_addr, u_int16_t hi_port, u_int16_t lo_port, 
+        Packet *p, u_int32_t flags, int mode)
+{
+    struct sockaddr_storage pkt_ss;         /* packet IP address */
+    u_short pkt_port;                       /* packet port */
+    int global_except_addr_flag = 0; /* global exception flag is set */
+    int any_port_flag = 0;           /* any port flag set */
+    int except_addr_flag = 0;        /* any addr flag set */
+    int except_port_flag = 0;        /* port exception flag set */
+    int ip_match = 0;                /* flag to indicate addr match made */
+    IpAddrSet *idx;  /* ip addr struct indexer */
+    char *host = NULL;
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "CheckAddrPort: "););
+    /* set up the packet particulars */
+
+    if(mode & CHECK_SRC)
+    {
+        IpAddrGet(&pkt_ss, p, SRC);
+        pkt_port = p->sp;
+
+        DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"SRC "););
+
+        if(mode & INVERSE)
+        {
+            global_except_addr_flag = flags & EXCEPT_DST_IP;
+            any_port_flag = flags & ANY_DST_PORT;
+            except_port_flag = flags & EXCEPT_DST_PORT;
+        }
+        else
+        {
+            global_except_addr_flag = flags & EXCEPT_SRC_IP;
+            any_port_flag = flags & ANY_SRC_PORT;
+            except_port_flag = flags & EXCEPT_SRC_PORT;
+        }
+    }
+    else
+    {
+	 IpAddrGet(&pkt_ss, p, DST);
+	 pkt_port = p->dp;
+	
+	 DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "DST "););
+
+	 if(mode & INVERSE)
+	 {
+	      global_except_addr_flag = flags & EXCEPT_SRC_IP;
+	      any_port_flag = flags & ANY_SRC_PORT;
+	      except_port_flag = flags & EXCEPT_SRC_PORT;
+	 }
+	 else
+	 {
+	      global_except_addr_flag = flags & EXCEPT_DST_IP;
+	      any_port_flag = flags & ANY_DST_PORT;
+	      except_port_flag = flags & EXCEPT_DST_PORT;
+	 }
+    }
+
+    host = GetIpAddr(&pkt_ss);
+    if (host != NULL)
+    {
+	 DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "addr %s, port %d ", host, 
+				 pkt_port););	 
+    }
+    else
+    {
+	 DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "Unknown address, port %d ", pkt_addr, 
+				 pkt_port););
+    }
+
+    idx = rule_addr;
+    if(!(global_except_addr_flag)) /*modeled after Check{Src,Dst}IP function*/
+    {
+        while(idx != NULL)
+        {
+	     struct sockaddr_storage tmp_ss;
+	     memset(&tmp_ss, 0, sizeof(tmp_ss));
+
+	     except_addr_flag = idx->addr_flags & EXCEPT_IP;
+
+	     /* test the rule address vs. the packet address */
+	     if (idx->ip_addr.ss_family == PF_UNSPEC)
+		 idx->ip_addr.ss_family = pkt_ss.ss_family;
+	     if (idx->netmask.ss_family == PF_UNSPEC)
+		 idx->netmask.ss_family = pkt_ss.ss_family;
+	     IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+	     if(!((IpAddrEquals(&idx->ip_addr, &tmp_ss) == 0) ^ except_addr_flag))
+	     {
+		  idx = idx->next;
+	     }
+	     else
+	     {
+		  ip_match = 1;
+		  goto bail;
+	     }
+        }
+    }
+    else
+    {
+	 DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", global exception flag set"););
+	 /* global exception flag is up, we can't match on *any* 
+	  * of the source addresses 
+	  */
+	 while(idx != NULL)
+	 {
+	      struct sockaddr_storage tmp_ss;
+	      memset(&tmp_ss, 0, sizeof(tmp_ss));
+
+	      except_addr_flag = idx->addr_flags & EXCEPT_IP;
+
+	      /* test the rule address vs. the packet address */
+	      if(idx->ip_addr.ss_family == PF_UNSPEC)
+		  idx->ip_addr.ss_family = pkt_ss.ss_family;
+	      if(idx->netmask.ss_family == PF_UNSPEC)
+		  idx->netmask.ss_family = pkt_ss.ss_family;
+	      IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+	      if(!((IpAddrEquals(&idx->ip_addr, &tmp_ss) == 0) ^ except_addr_flag))
+	      {
+		   DEBUG_WRAP(DebugMessage(DEBUG_DETECT, 
+					   ", address matched, packet rejected\n"));
+		   
+		   /* got address match on globally negated rule, fail */
+		   return 0;
+	      }
+	      idx = idx->next;
+	 }
+	 ip_match = 1;
+    }
+ bail:
+    if(!ip_match)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", no address match,  "
+                    "packet rejected\n"););
+        return 0;
+    }
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", addresses accepted"););
+    
+    /* if the any port flag is up, we're all done (success) */
+    if(any_port_flag)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", any port match, "
+                    "packet accepted\n"););
+        return 1;
+    }
+
+    /* check the packet port against the rule port */
+    if((pkt_port > hi_port) || (pkt_port < lo_port))
+    {
+        /* if the exception flag isn't up, fail */
+        if(!except_port_flag)
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", port mismatch,  "
+                        "packet rejected\n"););
+            return 0;
+        }
+        DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", port mismatch exception"););
+    }
+    else
+    {
+        /* if the exception flag is up, fail */
+        if(except_port_flag)
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DETECT,
+				    ", port match exception,  packet rejected\n"););
+            return 0;
+        }
+        DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", ports match"););
+    }
+
+    /* ports and address match */
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT, ", packet accepted!\n"););
+    return 1;
+
+}
+#else
 int CheckAddrPort(IpAddrSet *rule_addr, u_int16_t hi_port, u_int16_t lo_port, 
         Packet *p, u_int32_t flags, int mode)
 {
@@ -504,7 +683,7 @@
     return 1;
 
 }
-
+#endif
 /****************************************************************************
  *
  * Function: DumpChain(RuleTreeNode *, char *, char *)
@@ -791,6 +970,90 @@
  * Returns: 0 on failure (no match), 1 on success (match)
  *
  ***************************************************************************/
+#ifdef HAVE_SOCKADDR_STORAGE
+int CheckSrcIP(Packet * p, struct _RuleTreeNode * rtn_idx, RuleFpList * fp_list)
+{
+     IpAddrSet *idx; /* ip address indexer */
+     struct sockaddr_storage tmp_ss, pkt_ss;
+
+     memset(&pkt_ss, 0, sizeof(pkt_ss));
+     IpAddrGet(&pkt_ss, p, SRC);
+
+     DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"CheckSrcIPEqual: "););
+
+     /* check for global exception flag */
+     if(!(rtn_idx->flags & EXCEPT_SRC_IP))
+     {
+	  /* do the check */
+	  for(idx=rtn_idx->sip; idx != NULL; idx=idx->next)
+	  {
+	       memset(&tmp_ss, 0, sizeof(tmp_ss));
+	       if (idx->ip_addr.ss_family == PF_UNSPEC)
+		   idx->ip_addr.ss_family = pkt_ss.ss_family;
+	       if (idx->netmask.ss_family == PF_UNSPEC)
+		   idx->netmask.ss_family = pkt_ss.ss_family;
+	       IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+	       if( ((IpAddrEquals(&idx->ip_addr, &tmp_ss) == 0)
+		    ^ (idx->addr_flags & EXCEPT_IP)) )
+	       {
+#ifdef DEBUG
+		    if(idx->addr_flags & EXCEPT_IP) {
+			 DebugMessage(DEBUG_DETECT, "  SIP exception match\n");
+		    } 
+		    else
+		    {
+			 DebugMessage(DEBUG_DETECT, "  SIP match\n");
+		    }
+
+		    {
+			 char *rule = NULL, *netmask = NULL;
+			 rule = GetIpAddr(&idx->ip_addr);
+			 netmask = GetIpAddr(&idx->netmask);
+			 if (rule != NULL && netmask != NULL) 
+			      DebugMessage(DEBUG_DETECT, "Rule: %s     Packet: %s\n", rule, netmask);
+		    }
+#endif /* DEBUG */
+
+		    /* the packet matches this test, proceed to the next test */
+		    return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
+	       }
+	  } 
+     }
+     else
+     {
+	  /* global exception flag is up, we can't match on *any* 
+	   * of the source addresses 
+	   */
+	  DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"  global exception flag, \n"););
+
+	  /* do the check */
+	  for(idx=rtn_idx->sip; idx != NULL; idx=idx->next)
+	  {
+	       memset(&tmp_ss, 0, sizeof(tmp_ss));
+	       if (idx->ip_addr.ss_family == PF_UNSPEC)
+		   idx->ip_addr.ss_family = pkt_ss.ss_family;
+	       if (idx->netmask.ss_family == PF_UNSPEC)
+		   idx->netmask.ss_family = pkt_ss.ss_family;
+	       IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+	       if( ((IpAddrEquals(&idx->ip_addr, &tmp_ss) == 0)
+		    ^ (idx->addr_flags & EXCEPT_IP)) )
+	       {
+		    DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"address matched, failing on SIP\n"););
+		    /* got address match on globally negated rule, fail */
+		    return 0;
+	       }
+	  }
+	  DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"no matches on SIP, passed\n"););
+	  
+	  return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
+     }
+    
+     DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"  Mismatch on SIP\n"););
+
+     /* return 0 on a failed test */
+     return 0;
+}
+#else
 int CheckSrcIP(Packet * p, struct _RuleTreeNode * rtn_idx, RuleFpList * fp_list)
 {
     IpAddrSet *idx; /* ip address indexer */
@@ -852,7 +1115,7 @@
     /* return 0 on a failed test */
     return 0;
 }
-
+#endif
 
 
 /****************************************************************************
@@ -869,6 +1132,40 @@
  * Returns: 0 on failure (no match), 1 on success (match)
  *
  ***************************************************************************/
+#if HAVE_SOCKADDR_STORAGE
+int CheckSrcIPNotEq(Packet *p, struct _RuleTreeNode *rtn_idx, 
+        RuleFpList *fp_list)
+{
+    IpAddrSet *idx;  /* IP address indexer */
+    struct sockaddr_storage tmp_ss, pkt_ss;
+
+    memset(&pkt_ss, 0, sizeof(pkt_ss));
+    IpAddrGet(&pkt_ss, p, SRC);
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "CheckSrcIPNotEq: "););
+    /* do the check */
+    for(idx=rtn_idx->sip; idx != NULL; idx=idx->next)
+    {
+	memset(&tmp_ss, 0, sizeof(tmp_ss));
+	if (idx->ip_addr.ss_family == PF_UNSPEC)
+	    idx->ip_addr.ss_family = pkt_ss.ss_family;
+	if (idx->netmask.ss_family == PF_UNSPEC)
+	    idx->netmask.ss_family = pkt_ss.ss_family;
+	IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+        if( IpAddrEquals(&idx->ip_addr, &tmp_ss) != 0 )
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "  SIP exception match\n"););
+            /* the packet matches this test, proceed to the next test */
+            return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
+        }
+    }
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "  Mismatch on SIP\n"););
+    
+    /* return 0 on a failed test */
+    return 0;
+}
+#else
 int CheckSrcIPNotEq(Packet *p, struct _RuleTreeNode *rtn_idx, 
         RuleFpList *fp_list)
 {
@@ -891,7 +1188,7 @@
     /* return 0 on a failed test */
     return 0;
 }
-
+#endif
 
 
 /****************************************************************************
@@ -907,6 +1204,91 @@
  * Returns: 0 on failure (no match), 1 on success (match)
  *
  ***************************************************************************/
+#ifdef HAVE_SOCKADDR_STORAGE
+int CheckDstIP(Packet *p, struct _RuleTreeNode *rtn_idx, RuleFpList *fp_list)
+{
+    IpAddrSet *idx;  /* ip address indexer */
+    struct sockaddr_storage tmp_ss, pkt_ss;
+
+    memset(&pkt_ss, 0, sizeof(pkt_ss));
+    IpAddrGet(&pkt_ss, p, DST);
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT, "CheckDstIPEqual: ");)
+
+    /* check for global exception flag */
+    if(!(rtn_idx->flags & EXCEPT_DST_IP))
+    {
+	 /* do the check */
+	 for(idx=rtn_idx->dip; idx != NULL; idx=idx->next)
+	  {
+	       memset(&tmp_ss, 0, sizeof(tmp_ss));
+	       if (idx->ip_addr.ss_family == PF_UNSPEC)
+		   idx->ip_addr.ss_family = pkt_ss.ss_family;
+	       if (idx->netmask.ss_family == PF_UNSPEC)
+		   idx->netmask.ss_family = pkt_ss.ss_family;
+	       IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+	       if( ((IpAddrEquals(&idx->ip_addr, &tmp_ss) == 0)
+		    ^ (idx->addr_flags & EXCEPT_IP)) )
+	       {
+#ifdef DEBUG
+		    if(idx->addr_flags & EXCEPT_IP) {
+			 DebugMessage(DEBUG_DETECT, "  SIP exception match\n");
+		    } 
+		    else
+		    {
+			 DebugMessage(DEBUG_DETECT, "  SIP match\n");
+		    }
+
+		    {
+			 char *rule = NULL, *netmask = NULL;
+			 rule = GetIpAddr(&idx->ip_addr);
+			 netmask = GetIpAddr(&idx->netmask);
+			 if (rule != NULL && netmask != NULL) 
+			      DebugMessage(DEBUG_DETECT, "Rule: %s     Packet: %s\n", rule, netmask);
+		    }
+#endif /* DEBUG */
+
+		    /* the packet matches this test, proceed to the next test */
+		    return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
+	       }
+	  } 
+     }
+     else
+     {
+	  /* global exception flag is up, we can't match on *any* 
+	   * of the source addresses 
+	   */
+	  DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"  global exception flag, \n"););
+
+	  /* do the check */
+	  for(idx=rtn_idx->dip; idx != NULL; idx=idx->next)
+	  {
+	       memset(&tmp_ss, 0, sizeof(tmp_ss));
+	       if (idx->ip_addr.ss_family == PF_UNSPEC)
+		   idx->ip_addr.ss_family = pkt_ss.ss_family;
+	       if (idx->netmask.ss_family == PF_UNSPEC)
+		   idx->netmask.ss_family = pkt_ss.ss_family;
+	       IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+	       if( ((IpAddrEquals(&idx->ip_addr, &tmp_ss) == 0)
+		    ^ (idx->addr_flags & EXCEPT_IP)) )
+	       {
+		    DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"address matched, failing on SIP\n"););
+		    /* got address match on globally negated rule, fail */
+		    return 0;
+	       }
+	  }
+	  DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"no matches on SIP, passed\n"););
+	  
+	  return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
+     }
+    
+     DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"  Mismatch on SIP\n"););
+
+     /* return 0 on a failed test */
+     return 0;
+
+}
+#else
 int CheckDstIP(Packet *p, struct _RuleTreeNode *rtn_idx, RuleFpList *fp_list)
 {
     IpAddrSet *idx;  /* ip address indexer */
@@ -933,7 +1315,7 @@
                 }
                 
                 DebugMessage(DEBUG_DETECT, "Rule: 0x%X     Packet: 0x%X\n", 
-                        idx->ip_addr, (p->iph->ip_src.s_addr & idx->netmask));
+                        idx->ip_addr, (p->iph->ip_dst.s_addr & idx->netmask));
 #endif /* DEBUG */
                 /* the packet matches this test, proceed to the next test */
                 return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
@@ -968,7 +1350,7 @@
     /* return 0 on a failed test */
     return 0;
 }
-
+#endif
 
 /****************************************************************************
  *
@@ -983,6 +1365,39 @@
  * Returns: 0 on failure (no match), 1 on success (match)
  *
  ***************************************************************************/
+#if HAVE_SOCKADDR_STORAGE
+int CheckDstIPNotEq(Packet *p, struct _RuleTreeNode *rtn_idx, 
+		    RuleFpList *fp_list)
+{
+    IpAddrSet *idx; /* ip address indexer */
+    struct sockaddr_storage tmp_ss, pkt_ss;
+
+    memset(&pkt_ss, 0, sizeof(pkt_ss));
+    IpAddrGet(&pkt_ss, p, DST);
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"CheckDstIPNotEq: "););
+
+    /* same as above */
+    for(idx=rtn_idx->dip;idx != NULL; idx=idx->next)
+    {
+	memset(&tmp_ss, 0, sizeof(tmp_ss));
+	if (idx->ip_addr.ss_family == PF_UNSPEC)
+	    idx->ip_addr.ss_family = pkt_ss.ss_family;
+	if (idx->netmask.ss_family == PF_UNSPEC)
+	    idx->netmask.ss_family = pkt_ss.ss_family;
+	IpAddrTakeAnd(&tmp_ss, &pkt_ss, &idx->netmask);
+        if( IpAddrEquals(&idx->ip_addr, &tmp_ss) != 0 )
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"  DIP exception match\n"););
+            return fp_list->next->RuleHeadFunc(p, rtn_idx, fp_list->next);
+        }
+    }
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DETECT,"  Mismatch on DIP\n"););
+
+    return 0;
+}
+#else
 int CheckDstIPNotEq(Packet *p, struct _RuleTreeNode *rtn_idx, 
         RuleFpList *fp_list)
 {
@@ -1004,7 +1419,7 @@
 
     return 0;
 }
-
+#endif
 
 
 int CheckSrcPortEqual(Packet *p, struct _RuleTreeNode *rtn_idx, 
@@ -1174,9 +1589,11 @@
     {
         node->RuleList = (ListHead *)calloc(1, sizeof(ListHead));
         node->RuleList->IpList = NULL;
+        node->RuleList->Ip6List = NULL;
         node->RuleList->TcpList = NULL;
         node->RuleList->UdpList = NULL;
         node->RuleList->IcmpList = NULL;
+        node->RuleList->Icmp6List = NULL;
         node->RuleList->LogList = NULL;
         node->RuleList->AlertList = NULL;
     }
diff -ur snort-2.0.2/src/detect.h snort-2.0.2-ipv6/src/detect.h
--- snort-2.0.2/src/detect.h	Tue Nov 19 05:18:17 2002
+++ snort-2.0.2-ipv6/src/detect.h	Tue Sep 30 13:25:25 2003
@@ -1,4 +1,4 @@
-/* $Id: detect.h,v 1.8 2002/11/18 20:18:17 chrisgreen Exp $ */
+/* $Id: detect.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
diff -ur snort-2.0.2/src/detection-plugins/Makefile.am snort-2.0.2-ipv6/src/detection-plugins/Makefile.am
--- snort-2.0.2/src/detection-plugins/Makefile.am	Tue Nov  5 23:49:22 2002
+++ snort-2.0.2-ipv6/src/detection-plugins/Makefile.am	Thu Dec  4 13:32:52 2003
@@ -15,6 +15,10 @@
 sp_tcp_flag_check.h sp_tcp_flag_check.c sp_tcp_seq_check.c sp_tcp_seq_check.h  \
 sp_tcp_win_check.c sp_tcp_win_check.h sp_ttl_check.c sp_ttl_check.h            \
 sp_clientserver.c sp_clientserver.h sp_byte_check.c sp_byte_check.h            \
-sp_byte_jump.c sp_byte_jump.h
+sp_byte_jump.c sp_byte_jump.h \
+sp_hlim_check.c sp_hlim_check.h \
+sp_icmp6_id_check.c sp_icmp6_id_check.h sp_icmp6_seq_check.c sp_icmp6_seq_check.h \
+sp_icmp6_code_check.c sp_icmp6_code_check.h sp_icmp6_type_check.c sp_icmp6_type_check.h \
+sp_ip6_proto.c sp_ip6_proto.h
 
 INCLUDES = @INCLUDES@
diff -ur snort-2.0.2/src/detection-plugins/sp_byte_check.c snort-2.0.2-ipv6/src/detection-plugins/sp_byte_check.c
--- snort-2.0.2/src/detection-plugins/sp_byte_check.c	Thu Jun  5 04:27:34 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_byte_check.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: sp_byte_check.c,v 1.19 2003/05/31 13:34:38 cazz Exp $ */
+/* $Id: sp_byte_check.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /* Copyright (C) 2002 Sourcefire Inc. */
 /* Author: Martin Roesch*/
 
diff -ur snort-2.0.2/src/detection-plugins/sp_byte_check.h snort-2.0.2-ipv6/src/detection-plugins/sp_byte_check.h
--- snort-2.0.2/src/detection-plugins/sp_byte_check.h	Fri Mar 14 17:28:52 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_byte_check.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: sp_byte_check.h,v 1.2 2003/03/14 08:28:52 chris_reid Exp $ */
+/* $Id: sp_byte_check.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 #ifndef __SP_BYTE_CHECK_H__
 #define __SP_BYTE_CHECK_H__
diff -ur snort-2.0.2/src/detection-plugins/sp_byte_jump.c snort-2.0.2-ipv6/src/detection-plugins/sp_byte_jump.c
--- snort-2.0.2/src/detection-plugins/sp_byte_jump.c	Wed May 14 00:55:33 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_byte_jump.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: sp_byte_jump.c,v 1.13 2003/05/13 15:55:33 chrisgreen Exp $ */
+/* $Id: sp_byte_jump.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /* Copyright (C) 2002 Sourcefire Inc. */
 /* Author: Martin Roesch*/
 
diff -ur snort-2.0.2/src/detection-plugins/sp_byte_jump.h snort-2.0.2-ipv6/src/detection-plugins/sp_byte_jump.h
--- snort-2.0.2/src/detection-plugins/sp_byte_jump.h	Fri Mar 14 17:28:52 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_byte_jump.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: sp_byte_jump.h,v 1.2 2003/03/14 08:28:52 chris_reid Exp $ */
+/* $Id: sp_byte_jump.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 #ifndef __SP_BYTE_JUMP_H__
 #define __SP_BYTE_JUMP_H__
diff -ur snort-2.0.2/src/detection-plugins/sp_clientserver.c snort-2.0.2-ipv6/src/detection-plugins/sp_clientserver.c
--- snort-2.0.2/src/detection-plugins/sp_clientserver.c	Thu Mar 27 06:59:32 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_clientserver.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: sp_clientserver.c,v 1.18 2003/03/26 21:59:32 chrisgreen Exp $ */
+/* $Id: sp_clientserver.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* sp_clientserver 
  * 
diff -ur snort-2.0.2/src/detection-plugins/sp_clientserver.h snort-2.0.2-ipv6/src/detection-plugins/sp_clientserver.h
--- snort-2.0.2/src/detection-plugins/sp_clientserver.h	Fri Mar 14 17:28:52 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_clientserver.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: sp_clientserver.h,v 1.5 2003/03/14 08:28:52 chris_reid Exp $ */
+/* $Id: sp_clientserver.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /* ClientServer detection plugin header */
 
 #ifndef __SP_CLIENTSERVER_H__
diff -ur snort-2.0.2/src/detection-plugins/sp_dsize_check.c snort-2.0.2-ipv6/src/detection-plugins/sp_dsize_check.c
--- snort-2.0.2/src/detection-plugins/sp_dsize_check.c	Wed May 14 05:53:52 2003
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_dsize_check.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: sp_dsize_check.c,v 1.14 2003/05/13 20:53:52 chrisgreen Exp $ */
+/* $Id: sp_dsize_check.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
diff -ur snort-2.0.2/src/detection-plugins/sp_dsize_check.h snort-2.0.2-ipv6/src/detection-plugins/sp_dsize_check.h
--- snort-2.0.2/src/detection-plugins/sp_dsize_check.h	Tue May 14 05:14:06 2002
+++ snort-2.0.2-ipv6/src/detection-plugins/sp_dsize_check.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: sp_dsize_check.h,v 1.5 2002/05/13 20:14:06 chrisgreen Exp $ */
+/* $Id: sp_dsize_check.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 #ifndef __SP_DSIZE_CHECK_H__
 #define __SP_DSIZE_CHECK_H__
 
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_hlim_check.c
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_hlim_check.h
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_code_check.c
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_code_check.h
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_id_check.c
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_id_check.h
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_seq_check.c
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_seq_check.h
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_type_check.c
Only in snort-2.0.2-ipv6/src/detection-plugins: sp_icmp6_type_check.h
